import { getEntry } from './view-model-reducer';
import { useSelector } from 'react-redux';

function useReduxViewModelSelector(query) {
  if (typeof query === 'string') {
    return useSelector(function (state) {
      return getEntry(state.viewModels, query);
    });
  }

  return useSelector(function (state) {
    return getEntry(state.viewModels, {
      query: query
    });
  });
}

export { useReduxViewModelSelector };
//# sourceMappingURL=use-redux-view-model-selector.js.map