import _regeneratorRuntime from "@babel/runtime/regenerator";
import _extends from "@babel/runtime/helpers/esm/extends";
import { take } from 'redux-saga/effects';
import getHash from '../internal/get-hash';
import createSagaManager from '../internal/create-saga-manager';
import { CONNECT_VIEWMODEL, DISCONNECT_VIEWMODEL } from '../internal/action-types';
import connectViewModelSaga from './connect-view-model-saga';
import disconnectViewModelSaga from './disconnect-view-model-saga';

var viewModelsSaga = /*#__PURE__*/_regeneratorRuntime.mark(function viewModelsSaga(sagaArgs) {
  var sagaManager, action, query, selectorId, sagaKey, _query, _selectorId, _sagaKey;

  return _regeneratorRuntime.wrap(function viewModelsSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          sagaManager = createSagaManager();

        case 1:
          if (!true) {
            _context.next = 18;
            break;
          }

          _context.next = 4;
          return take([CONNECT_VIEWMODEL, DISCONNECT_VIEWMODEL]);

        case 4:
          action = _context.sent;
          _context.t0 = action.type;
          _context.next = _context.t0 === CONNECT_VIEWMODEL ? 8 : _context.t0 === DISCONNECT_VIEWMODEL ? 12 : 16;
          break;

        case 8:
          query = action.query, selectorId = action.selectorId;
          sagaKey = selectorId || getHash(query);
          return _context.delegateYield(sagaManager.start("" + CONNECT_VIEWMODEL + sagaKey, connectViewModelSaga, _extends({}, sagaArgs, {
            sagaManager: sagaManager,
            sagaKey: sagaKey
          }), action), "t1", 11);

        case 11:
          return _context.abrupt("break", 16);

        case 12:
          _query = action.query, _selectorId = action.selectorId;
          _sagaKey = _selectorId || getHash(_query);
          return _context.delegateYield(sagaManager.start("" + DISCONNECT_VIEWMODEL + _sagaKey, disconnectViewModelSaga, _extends({}, sagaArgs, {
            sagaManager: sagaManager,
            sagaKey: _sagaKey
          }), action), "t2", 15);

        case 15:
          return _context.abrupt("break", 16);

        case 16:
          _context.next = 1;
          break;

        case 18:
        case "end":
          return _context.stop();
      }
    }
  }, viewModelsSaga);
});

export default viewModelsSaga;
//# sourceMappingURL=view-models-saga.js.map