"use strict";

exports.__esModule = true;
exports.sendCommandFailure = exports.sendCommandSuccess = exports.sendCommandRequest = void 0;

var _actionTypes = require("../internal/action-types");

var sendCommandRequest = function sendCommandRequest(command, usedByHook) {
  return {
    type: _actionTypes.SEND_COMMAND_REQUEST,
    command: command,
    usedByHook: usedByHook
  };
};

exports.sendCommandRequest = sendCommandRequest;

var sendCommandSuccess = function sendCommandSuccess(command, result) {
  return {
    type: _actionTypes.SEND_COMMAND_SUCCESS,
    command: command,
    result: result
  };
};

exports.sendCommandSuccess = sendCommandSuccess;

var sendCommandFailure = function sendCommandFailure(command, error) {
  return {
    type: _actionTypes.SEND_COMMAND_FAILURE,
    command: command,
    error: error
  };
};

exports.sendCommandFailure = sendCommandFailure;
//# sourceMappingURL=actions.js.map