"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _effects = require("redux-saga/effects");

var _actionTypes = require("../internal/action-types");

var _sendCommandSaga = _interopRequireDefault(require("./send-command-saga"));

var isSendCommandAction = function isSendCommandAction(action) {
  return action.type === _actionTypes.SEND_COMMAND_REQUEST;
};

var commandSaga = /*#__PURE__*/_regenerator["default"].mark(function commandSaga(sagaArgs) {
  return _regenerator["default"].wrap(function commandSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _effects.takeEvery)(function (action) {
            if (isSendCommandAction(action)) {
              return !action.usedByHook;
            }

            return false;
          }, _sendCommandSaga["default"], sagaArgs);

        case 2:
        case "end":
          return _context.stop();
      }
    }
  }, commandSaga);
});

var _default = commandSaga;
exports["default"] = _default;
//# sourceMappingURL=command-saga.js.map