"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _reduxSaga = _interopRequireDefault(require("redux-saga"));

var _client = require("@resolve-js/client");

var _rootSaga = _interopRequireDefault(require("./root-saga"));

var emptySaga = /*#__PURE__*/_regenerator["default"].mark(function emptySaga() {
  return _regenerator["default"].wrap(function emptySaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
        case "end":
          return _context.stop();
      }
    }
  }, emptySaga);
});

var wrapSagaMiddleware = function wrapSagaMiddleware(sagaMiddleware) {
  var run = function run(isClient, context) {
    var client = (0, _client.getClient)(context.resolveContext);
    var queryIdMap = new Map();
    var resolveContext = context.resolveContext,
        restContext = (0, _objectWithoutPropertiesLoose2["default"])(context, ["resolveContext"]);
    var backCompatibleArgs = (0, _extends2["default"])({}, restContext, resolveContext);
    sagaMiddleware.run(isClient ? _rootSaga["default"] : emptySaga, (0, _extends2["default"])({}, backCompatibleArgs, {
      queryIdMap: queryIdMap,
      client: client
    }));
  };

  var middleware = function middleware() {
    return sagaMiddleware.apply(void 0, arguments);
  };

  Object.defineProperty(middleware, 'run', {
    get: function get() {
      return run;
    }
  });
  return middleware;
};

var createResolveMiddleware = function createResolveMiddleware() {
  return wrapSagaMiddleware((0, _reduxSaga["default"])());
};

var _default = createResolveMiddleware;
exports["default"] = _default;
//# sourceMappingURL=create-resolve-middleware.js.map