"use strict";

exports.__esModule = true;
exports.initReadModel = exports.disconnectReadModel = exports.connectReadModel = exports.dropReadModelResult = exports.queryReadModelFailure = exports.queryReadModelSuccess = exports.queryReadModelRequest = void 0;

var _actionTypes = require("../internal/action-types");

var queryReadModelRequest = function queryReadModelRequest(query, initialState, selectorId) {
  return {
    type: _actionTypes.QUERY_READMODEL_REQUEST,
    query: query,
    initialState: initialState,
    selectorId: selectorId
  };
};

exports.queryReadModelRequest = queryReadModelRequest;

var queryReadModelSuccess = function queryReadModelSuccess(query, result, selectorId) {
  return {
    type: _actionTypes.QUERY_READMODEL_SUCCESS,
    query: query,
    result: result,
    selectorId: selectorId
  };
};

exports.queryReadModelSuccess = queryReadModelSuccess;

var queryReadModelFailure = function queryReadModelFailure(query, error, selectorId) {
  return {
    type: _actionTypes.QUERY_READMODEL_FAILURE,
    query: query,
    error: error,
    selectorId: selectorId
  };
};

exports.queryReadModelFailure = queryReadModelFailure;

var dropReadModelResult = function dropReadModelResult(query, selectorId) {
  return {
    type: _actionTypes.DROP_READMODEL_STATE,
    query: query,
    selectorId: selectorId
  };
};

exports.dropReadModelResult = dropReadModelResult;

var connectReadModel = function connectReadModel(query, skipConnectionManager) {
  return {
    type: _actionTypes.CONNECT_READMODEL,
    query: query,
    skipConnectionManager: skipConnectionManager
  };
};

exports.connectReadModel = connectReadModel;

var disconnectReadModel = function disconnectReadModel(query) {
  return {
    type: _actionTypes.DISCONNECT_READMODEL,
    query: query
  };
};

exports.disconnectReadModel = disconnectReadModel;

var initReadModel = function initReadModel(initialState, query, selectorId) {
  return {
    type: _actionTypes.INIT_READMODEL,
    query: query,
    selectorId: selectorId,
    initialState: initialState
  };
};

exports.initReadModel = initReadModel;
//# sourceMappingURL=actions.js.map