"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireDefault(require("react"));

var _helpers = require("../helpers");

var PropsResolver = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inheritsLoose2["default"])(PropsResolver, _React$PureComponent);

  function PropsResolver() {
    return _React$PureComponent.apply(this, arguments) || this;
  }

  var _proto = PropsResolver.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        innerRef = _this$props.innerRef,
        propList = _this$props.propList,
        TargetComponent = _this$props.TargetComponent,
        resolver = _this$props.resolver,
        props = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["innerRef", "propList", "TargetComponent", "resolver"]);
    var propsListSize = propList.length;
    var resolvedProps = {};

    for (var propertyIndex = 0; propertyIndex < propsListSize; propertyIndex++) {
      var propertyName = propList[propertyIndex];
      var propertyValue = props[propertyName];

      if (Array.isArray(propertyValue)) {
        var subProps = [];
        var subPropertySize = propertyValue.length;

        for (var subPropertyIndex = 0; subPropertyIndex < subPropertySize; subPropertyIndex++) {
          subProps[subPropertyIndex] = resolver(propertyValue[subPropertyIndex]);
        }

        resolvedProps[propertyName] = subProps;
      } else {
        resolvedProps[propertyName] = resolver(propertyValue);
      }
    }

    return /*#__PURE__*/_react["default"].createElement(TargetComponent, (0, _extends2["default"])({}, props, resolvedProps, {
      ref: innerRef
    }));
  };

  return PropsResolver;
}(_react["default"].PureComponent);

var createContextBasedConnector = function createContextBasedConnector(hook) {
  return function (propList) {
    return function (Component) {
      (0, _helpers.arrayOfString)(propList, 'Prop list');
      return function (props) {
        var resolver = hook();
        return /*#__PURE__*/_react["default"].createElement(PropsResolver, (0, _extends2["default"])({
          TargetComponent: Component,
          propList: propList,
          resolver: resolver
        }, props));
      };
    };
  };
};

var _default = createContextBasedConnector;
exports["default"] = _default;
//# sourceMappingURL=create-context-based-connector.js.map