"use strict";

exports.__esModule = true;
exports.disconnectViewModel = exports.connectViewModel = exports.dropViewModelState = exports.viewModelEventReceived = exports.viewModelStateUpdate = exports.queryViewModelFailure = exports.queryViewModelSuccess = exports.queryViewModelRequest = void 0;

var _actionTypes = require("../internal/action-types");

var queryViewModelRequest = function queryViewModelRequest(query, selectorId) {
  return {
    type: _actionTypes.QUERY_VIEWMODEL_REQUEST,
    query: query,
    selectorId: selectorId
  };
};

exports.queryViewModelRequest = queryViewModelRequest;

var queryViewModelSuccess = function queryViewModelSuccess(query, result, selectorId) {
  return {
    type: _actionTypes.QUERY_VIEWMODEL_SUCCESS,
    query: query,
    result: result,
    selectorId: selectorId
  };
};

exports.queryViewModelSuccess = queryViewModelSuccess;

var queryViewModelFailure = function queryViewModelFailure(query, error, selectorId) {
  return {
    type: _actionTypes.QUERY_VIEWMODEL_FAILURE,
    query: query,
    error: error,
    selectorId: selectorId
  };
};

exports.queryViewModelFailure = queryViewModelFailure;

var viewModelStateUpdate = function viewModelStateUpdate(query, state, initial, selectorId) {
  return {
    type: _actionTypes.VIEWMODEL_STATE_UPDATE,
    query: query,
    state: state,
    initial: initial,
    selectorId: selectorId
  };
};

exports.viewModelStateUpdate = viewModelStateUpdate;

var viewModelEventReceived = function viewModelEventReceived(query, event, selectorId) {
  return {
    type: _actionTypes.VIEWMODEL_EVENT_RECEIVED,
    query: query,
    event: event,
    selectorId: selectorId
  };
};

exports.viewModelEventReceived = viewModelEventReceived;

var dropViewModelState = function dropViewModelState(query, selectorId) {
  return {
    type: _actionTypes.DROP_VIEWMODEL_STATE,
    query: query,
    selectorId: selectorId
  };
};

exports.dropViewModelState = dropViewModelState;

var connectViewModel = function connectViewModel(query, selectorId) {
  return {
    type: _actionTypes.CONNECT_VIEWMODEL,
    query: query,
    selectorId: selectorId
  };
};

exports.connectViewModel = connectViewModel;

var disconnectViewModel = function disconnectViewModel(query, selectorId) {
  return {
    type: _actionTypes.DISCONNECT_VIEWMODEL,
    query: query,
    selectorId: selectorId
  };
};

exports.disconnectViewModel = disconnectViewModel;
//# sourceMappingURL=actions.js.map