"use strict";

exports.__esModule = true;
exports.useReduxViewModelSelector = useReduxViewModelSelector;

var _viewModelReducer = require("./view-model-reducer");

var _reactRedux = require("react-redux");

function useReduxViewModelSelector(query) {
  if (typeof query === 'string') {
    return (0, _reactRedux.useSelector)(function (state) {
      return (0, _viewModelReducer.getEntry)(state.viewModels, query);
    });
  }

  return (0, _reactRedux.useSelector)(function (state) {
    return (0, _viewModelReducer.getEntry)(state.viewModels, {
      query: query
    });
  });
}
//# sourceMappingURL=use-redux-view-model-selector.js.map