import { QUERY_READMODEL_REQUEST, QUERY_READMODEL_SUCCESS, QUERY_READMODEL_FAILURE, DROP_READMODEL_STATE, CONNECT_READMODEL, DISCONNECT_READMODEL, INIT_READMODEL } from '../internal/action-types';
import { ReadModelQuery } from '@resolve-js/client';
export declare type ReadModelAction = {
    query: ReadModelQuery;
    selectorId?: string;
};
export declare type QueryReadModelRequestAction = {
    type: typeof QUERY_READMODEL_REQUEST;
    initialState: any;
    selectorId?: string;
} & ReadModelAction;
export declare const queryReadModelRequest: (query: ReadModelQuery, initialState: any, selectorId?: string | undefined) => QueryReadModelRequestAction;
export declare type QueryReadModelSuccessAction = {
    type: typeof QUERY_READMODEL_SUCCESS;
    result: any;
} & ReadModelAction;
export declare const queryReadModelSuccess: (query: ReadModelQuery, result: any, selectorId?: string | undefined) => QueryReadModelSuccessAction;
export declare type QueryReadModelFailureAction = {
    type: typeof QUERY_READMODEL_FAILURE;
    error: Error;
} & ReadModelAction;
export declare const queryReadModelFailure: (query: ReadModelQuery, error: Error, selectorId?: string | undefined) => QueryReadModelFailureAction;
export declare type DropReadModelResultAction = {
    type: typeof DROP_READMODEL_STATE;
} & ReadModelAction;
export declare const dropReadModelResult: (query: ReadModelQuery, selectorId?: string | undefined) => DropReadModelResultAction;
export declare type ConnectReadModelAction = {
    type: typeof CONNECT_READMODEL;
    skipConnectionManager?: boolean;
} & ReadModelAction;
export declare const connectReadModel: (query: ReadModelQuery, skipConnectionManager?: boolean | undefined) => ConnectReadModelAction;
export declare type DisconnectReadModelAction = {
    type: typeof DISCONNECT_READMODEL;
} & ReadModelAction;
export declare const disconnectReadModel: (query: ReadModelQuery) => DisconnectReadModelAction;
export declare type InitReadModelAction = {
    type: typeof INIT_READMODEL;
    initialState: any;
} & ReadModelAction;
export declare const initReadModel: (initialState: any, query?: ReadModelQuery | undefined, selectorId?: string | undefined) => {
    type: string;
    query: ReadModelQuery | undefined;
    selectorId: string | undefined;
    initialState: any;
};
