import { ReadModelQuery } from '@resolve-js/client';
import { DropReadModelResultAction, QueryReadModelFailureAction, QueryReadModelRequestAction, QueryReadModelSuccessAction, InitReadModelAction } from './actions';
import { ReadModelResultEntry, ReadModelResultMapByName, ResultStatus } from '../types';
declare type ReadModelActions = DropReadModelResultAction | QueryReadModelFailureAction | QueryReadModelRequestAction | QueryReadModelSuccessAction | InitReadModelAction;
export declare const namedSelectors = "namedSelectors";
export declare const badSelectorDrain = "badSelectorDrain";
export declare const builtInSelectors = "builtInSelectors";
declare type ReadModelResultEntrySelector = {
    query: ReadModelQuery;
};
export declare type ReadModelReducerState = {
    [namedSelectors]?: {
        [key: string]: ReadModelResultEntry;
    };
    [badSelectorDrain]?: ReadModelResultEntry;
    [builtInSelectors]?: ReadModelResultMapByName;
};
export declare const getEntry: (state: ReadModelResultMapByName | undefined, selector: ReadModelResultEntrySelector | string, placeholder?: {
    status: ResultStatus;
    data?: any;
    timestamp?: number | undefined;
    error?: Error | undefined;
} | undefined) => ReadModelResultEntry;
export declare const reducer: (state: ReadModelReducerState | undefined, action: ReadModelActions) => ReadModelReducerState;
export {};
