import { ViewModelResultEntry, ViewModelResultMapByName, ResultStatus } from '../types';
import { DropViewModelStateAction, ViewModelStateUpdateAction } from './actions';
import { ViewModelQuery } from '@resolve-js/client';
declare type ViewModelActions = DropViewModelStateAction | ViewModelStateUpdateAction;
export declare const namedSelectors = "namedSelectors";
export declare const builtInSelectors = "builtInSelectors";
declare type ViewModelResultSelector = {
    query: ViewModelQuery;
};
export declare type ViewModelReducerState = {
    [namedSelectors]?: {
        [key: string]: ViewModelResultEntry;
    };
    [builtInSelectors]?: ViewModelResultMapByName;
};
export declare const getEntryPath: (selector: ViewModelResultSelector | string) => string;
export declare const getEntry: (state: ViewModelResultMapByName | undefined, selector: ViewModelResultSelector | string, placeholder?: {
    status: ResultStatus;
    data?: any;
    timestamp?: number | undefined;
    error?: Error | undefined;
} | undefined) => ViewModelResultEntry;
export declare const reducer: (state: ViewModelReducerState | undefined, action: ViewModelActions) => ViewModelReducerState;
export {};
